/** Main file for USB storage key **/

#include <avr/io.h>
#include <util/delay.h>
#include <stdint.h>

#include "io.h"
#include "nand_public.h"

// Constants

#define LED_MAX		1
#define LED_DEBUG	0

#define PORTB_OUTPUT	0x01
#define PORTC_OUTPUT	0x00
#define PORTD_OUTPUT	0x00

#define BLINK_FIRST	10
#define BLINK_LAST	5
#define BLINK_DELAY	100
#define BIT_DELAY	1000

unsigned char led1[]={0x01,0x00,0x00};

unsigned char *leds[]={led1};

void blink_basic(int nb,int led){
int i;
for(i=0;i<nb;i++){
  output_set(leds,led); _delay_ms(BLINK_DELAY);
  output_unset(leds,led); _delay_ms(BLINK_DELAY);
  }
}

void blink_byte(uint8_t byte,int led){
int i;
for(i=0;i<8;i++){
  int nb=(byte&0x01)?2:1;
  int j;
  for(j=0;j<nb;j++){
    output_set(leds,led); _delay_ms(BLINK_DELAY);
    output_unset(leds,led); _delay_ms(BLINK_DELAY);
    }
  _delay_ms(BIT_DELAY);
  byte >>= 1;
  }
}

int main(void)
{
unsigned char omasks[]={PORTB_OUTPUT,PORTC_OUTPUT,PORTD_OUTPUT};
outputs_init(omasks);
blink_basic(BLINK_FIRST,LED_DEBUG);
_delay_ms(BIT_DELAY);
nand_init();
nand_reset();
uint8_t *id=nand_get_std_ID(0);
int i;
for(i=0;i<SIZE_ID_STD;i++) blink_byte(id[i],LED_DEBUG);
blink_basic(BLINK_LAST,LED_DEBUG);
return 0;
}
